clear
close all
clc

T = 3;
Fs = 8000;

t = linspace(0,T,T*Fs);
f = sin(2*pi*440*t);
figure(1);plot(t,f);axis([0,T,-2,2]);
xlabel('time');title('Tuning fork, "A"');
player = audioplayer(f,Fs);
tic;playblocking(player);toc
%sound(f,Fs)
%%

disp('hit "space" for next demo');pause

fork_sound = audioread('fork_clean.wav');
%fork_sound = wavread('fork_noisy.wav');
fs = 44100;
L = 44100*3;  % take first 3 seconds
fork_sound = fork_sound(1:L);
t = (0:L-1)*1/fs;

figure(1);
subplot(2,1,1)
plot(t,fork_sound);
xlabel('Time (sec)');
ylabel('Magnitude');
title('Time Signal');

subplot(2,1,2)
fork_spectrum = fft(fork_sound);
freq_range = fs*(1:length(fork_sound))/length(fork_sound)-fs/2;
stem(freq_range,abs(fftshift(fork_spectrum)),'.')
xlabel('Freq (Hz)');
ylabel('Magnitude');
title('Spectrum');

soundsc(fork_sound,fs)


disp('hit "space" for next demo');pause
%%
clear
close all

fork_sound = audioread('fork_noisy.wav');
fs = 44100;
L = 44100*3;  % take first 3 seconds
fork_sound = fork_sound(1:L);
t = (0:L-1)*1/fs;

figure(1);
subplot(2,1,1)
plot(t,fork_sound);
xlabel('Time (sec)');
ylabel('Magnitude');
title('Time Signal');

subplot(2,1,2)
fork_spectrum = fft(fork_sound);
freq_range = fs*(1:length(fork_sound))/length(fork_sound)-fs/2;
stem(freq_range,abs(fftshift(fork_spectrum)),'.')
xlabel('Freq (Hz)');
ylabel('Magnitude');
title('Spectrum');

soundsc(fork_sound,fs)
disp('hit "space" to denoise');pause
%%
% denoise by removing all spectral components less than 10% of max
denoised_spectrum = fork_spectrum.*(abs(fork_spectrum)>.10*max(abs(fork_spectrum)));
denoised_sound = ifft(denoised_spectrum);

figure(2);
subplot(2,1,1)
plot(t,denoised_sound);
xlabel('Time (sec)');
ylabel('Magnitude');
title('Time Signal');

subplot(2,1,2)
stem(freq_range,abs(fftshift(denoised_spectrum)),'.')
xlabel('Freq (Hz)');
ylabel('Magnitude');
title('Spectrum');

soundsc(denoised_sound,fs)


%%




% 
% load gong.mat
% sound(y,Fs);
% figure(2);plot(y);
% 
% disp('hit "space" for next demo');pause
% load handel.mat
% sound(y,Fs)
% sound(y,Fs*2)
% 
% 
