%% Tuning Fork Example
% First record the sound using audio recorder at 44100 samples/sec
% then export to .wav file
clear
close all
clc

fork_sound = wavread('fork_clean.wav');
%fork_sound = wavread('fork_noisy.wav');
fs = 44100;
L = 44100*3;  % take first 3 seconds
fork_sound = fork_sound(1:L);
t = (0:L-1)*1/fs;

figure(1);
subplot(2,1,1)
plot(t,fork_sound);
xlabel('Time (sec)');
ylabel('Magnitude');
title('Time Signal');

subplot(2,1,2)
fork_spectrum = fft(fork_sound);
freq_range = fs*(1:length(fork_sound))/length(fork_sound)-fs/2;
stem(freq_range,abs(fftshift(fork_spectrum)),'.')
xlabel('Freq (Hz)');
ylabel('Magnitude');
title('Spectrum');

soundsc(fork_sound,fs)



